import * as React from 'react';
export declare type Params<T extends (...args: never[]) => unknown> = T extends (...args: infer P) => any ? P : never;
export declare type RetType<T extends (...args: never[]) => unknown> = T extends (...args: never[]) => infer R ? R : any;
export declare type DropFirst<T extends any[]> = ((...args: T) => any) extends (arg: any, ...rest: infer U) => any[] ? U : T;
export declare type Tail<T> = T extends Array<any> ? ((...args: T) => never) extends ((a: any, ...args: infer R) => never) ? R : never : never;
declare type ContextReference<TState> = {
    state: TState;
    setState: React.Dispatch<React.SetStateAction<TState>>;
};
declare type Action<TState, TArgs extends never[] = never[], TReturn = any> = (contextReference: ContextReference<TState>, ...args: TArgs) => TReturn;
declare type Actions<TState> = {
    [key: string]: Action<TState>;
};
declare type MappedActions<TState, TActions extends Actions<TState>> = {
    [P in keyof TActions]: (...args: DropFirst<Params<TActions[P]>>) => RetType<TActions[P]>;
};
declare type Store<TState, TActions extends Actions<TState>> = TActions extends undefined ? TState : TState & MappedActions<TState, TActions>;
export default function createStoreContext<TState, TActions extends Actions<TState> = {}>(initialState: TState, actions?: TActions): [React.Context<Store<TState, TActions>>, React.FC];
export {};
